package array;

import java.util.ArrayDeque;
import java.util.Deque;

/**
 * 题目： 918. 环形子数组的最大和  (maxSubarraySumCircular)
 * 描述：给定一个长度为 n 的环形整数数组 nums ，返回 nums 的非空 子数组 的最大可能和 。
 *
 * 环形数组 意味着数组的末端将会与开头相连呈环状。形式上， nums[i] 的下一个元素是 nums[(i + 1) % n] ， nums[i] 的前一个元素是 nums[(i - 1 + n) % n] 。
 *
 * 子数组 最多只能包含固定缓冲区 nums 中的每个元素一次。形式上，对于子数组 nums[i], nums[i + 1], ..., nums[j] ，不存在 i <= k1, k2 <= j 其中 k1 % n == k2 % n 。
 *
 示例 1：
 输入：nums = [1,-2,3,-2]
 输出：3
 解释：从子数组 [3] 得到最大和 3
 *
 * 链接：https://leetcode.cn/problems/maximum-sum-circular-subarray/

 */
//不会
public class MaxSubarraySumCircular {
    //很巧妙的思路
    public int maxSubarraySumCircular(int[] nums) {
        int totalSum = 0;     // 数组元素总和
        int currMax = 0;      // Kadane 当前最大子数组和
        int maxSum = Integer.MIN_VALUE;  // 全局最大子数组和

        int currMin = 0;      // Kadane 当前最小子数组和
        int minSum = Integer.MAX_VALUE;  // 全局最小子数组和

        for (int x : nums) {
            // 累加总和
            totalSum += x;

            // —— 求最大子数组和（标准 Kadane） ——
            // 要么把 x 加到前面的子数组上，要么从 x 重新开始
            currMax = Math.max(currMax + x, x);
            maxSum = Math.max(maxSum, currMax);

            // —— 求最小子数组和（相反 Kadane） ——
            currMin = Math.min(currMin + x, x);
            minSum = Math.min(minSum, currMin);
        }

        // 如果所有元素都为负数，maxSum 会是最大的负数，
        // totalSum - minSum 会变成 0（等价于丢弃整个数组），不合法
        if (maxSum < 0) {
            return maxSum;
        }

        // 否则比较非环形和环形两种情况
        return Math.max(maxSum, totalSum - minSum);
    }
}
